package net.lecnam.info.remotelist;

import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Logger;
import net.lecnam.info.channel.ObjectReader;
import net.lecnam.info.channel.ObjectWriter;
import net.lecnam.info.channel.RemoteObjectReader;
import net.lecnam.info.channel.RemoteObjectWriter;

public class ServerMain {

	static Logger logger = Logger.getLogger("Server");

	public static void main(String[] args) throws IOException {

		List<String> l = new ArrayList<>();

		logger.info("Running...");
		ServerSocket ss = new ServerSocket(55000);

		boolean done = false;
		while (!done) {
			logger.info("Waiting for a new connection...");
			Socket s = ss.accept();
			logger.info("Client connected.");

			InputStream is = s.getInputStream();
			OutputStream os = s.getOutputStream();

			ObjectOutputStream out = new ObjectOutputStream(os);
			ObjectInputStream in = new ObjectInputStream(is);

			ObjectWriter<Answer<String>> outs = new RemoteObjectWriter<>(out);
			ObjectReader<Request<String>> ins = new RemoteObjectReader<>(in);

			Server<String> server = new Server<>(ins, outs, l);
			server.run();

			s.close();
			logger.info("Connection closed");
		}

		ss.close();
	}

}
